package io.gitlab.jfronny.libjf;

import io.gitlab.jfronny.commons.logger.SystemLoggerPlus;
import io.gitlab.jfronny.commons.throwable.Try;
import io.gitlab.jfronny.gson.JsonElement;

import java.util.function.BiConsumer;

public interface LoaderGlue {
    LoaderGlue INSTANCE = Try.orThrow(() -> {
        boolean isFabric = false;
        try {
            Class.forName("net.fabricmc.loader.api.FabricLoader");
            isFabric = true;
        } catch (Throwable t) {
        }
        if (isFabric) {
            return (LoaderGlue) Class.forName("io.gitlab.jfronny.libjf.fabric.FabricGlue").getConstructor().newInstance();
        } else {
            return (LoaderGlue) Class.forName("io.gitlab.jfronny.libjf.forge.ForgeGlue").getConstructor().newInstance();
        }
    });

    void obtainFlags(String name, BiConsumer<String, JsonElement> out);
    SystemLoggerPlus getEarlyLogger(String name);
    boolean isClient();
}
