import com.github.jengelman.gradle.plugins.shadow.transformers.ServiceFileTransformer
import com.github.jengelman.gradle.plugins.shadow.transformers.TransformerContext
import org.codehaus.plexus.util.IOUtil
import java.io.ByteArrayOutputStream

plugins {
    id("jfmod.module")
}

repositories {
    maven("https://maven.neoforged.net/releases")
}

base {
    archivesName = "libjf-forge"
}

lom {
    loaderVersion = "20.4.210"
}

dependencies {
    //TODO this dependency setup has only been tested in dev.
    //     It may not work in a production environment.
    "loomDevelopmentDependencies"(project(":libjf-base")) {
        isTransitive = false
    }
    shadow(project(":libjf-base", "dev")) {
        isTransitive = false
    }
    include(modImplementation("net.fabricmc.fabric-api:fabric-lifecycle-events-v1")!!)
    shadow(libs.bundles.commons)
}

// workaround to ensure our custom System.LoggerFinder is initialized early
// ideally, we would use the configuration API, but that seems to cause a class loading issue with fabric loader
//tasks.shadowJar {
//    val path = "META-INF/services/io.gitlab.jfronny.libjf.LoaderGlue"
//    val field = ServiceFileTransformer::class.java.getDeclaredField("serviceEntries").apply { isAccessible = true }
//    exclude(path)
//    transform(object: ServiceFileTransformer() {
//        private val serviceEntries get() = field.get(this) as MutableMap<String, Any>
//        override fun transform(context: TransformerContext?) {
//            super.transform(context)
//            (serviceEntries[path] as ByteArrayOutputStream).run {
//                reset()
//                file("src/main/resources/$path").inputStream().use { IOUtil.copy(it, this) }
//            }
//        }
//    })
//}