package io.gitlab.jfronny.libjf.forge;

import io.gitlab.jfronny.commons.logger.SystemLoggerPlus;
import io.gitlab.jfronny.gson.JsonElement;
import io.gitlab.jfronny.libjf.LibJf;
import io.gitlab.jfronny.libjf.LoaderGlue;
import io.gitlab.jfronny.libjf.log.SLF4JPlatformLogger;
import net.neoforged.api.distmarker.Dist;
import net.neoforged.fml.common.Mod;
import net.neoforged.fml.loading.FMLEnvironment;
import org.slf4j.LoggerFactory;

import java.util.ServiceLoader;
import java.util.function.BiConsumer;

public class ForgeGlue implements LoaderGlue {
    @Override
    public void obtainFlags(String name, BiConsumer<String, JsonElement> out) {
        ServiceLoader.load(ModFlagSource.class).stream().forEach(provider -> {
            JsonElement element = provider.get().obtain();
            if (element != null) {
                out.accept(provider.type().getName(), element);
            }
        });
    }

    @Override
    public SystemLoggerPlus getEarlyLogger(String name) {
        return new SLF4JPlatformLogger(LoggerFactory.getLogger(name));
    }

    @Override
    public boolean isClient() {
        return FMLEnvironment.dist == Dist.CLIENT;
    }
}
